.\" Automatically generated by Pandoc 2.5
.\"
.TH "dgw::tvmixins 0.2" "" "" "" ""
.hy
.SS NAME
.PP
\f[B]dgw::tvmixins\f[R] \- implementations of various extensions for the
*ttk::treeview** widget which can be added dynamically using chaining of
commands at widget creation.
.SS TABLE OF CONTENTS
.IP \[bu] 2
SYNOPSIS
.IP \[bu] 2
DESCRIPTION
.IP \[bu] 2
WIDGET COMMANDS
.IP \[bu] 2
EXAMPLE
.IP \[bu] 2
INSTALLATION
.IP \[bu] 2
DEMO
.IP \[bu] 2
DOCUMENTATION
.IP \[bu] 2
SEE ALSO
.IP \[bu] 2
CHANGES
.IP \[bu] 2
TODO
.IP \[bu] 2
AUTHORS
.IP \[bu] 2
COPYRIGHT
.IP \[bu] 2
LICENSE
.SS SYNOPSIS
.IP
.nf
\f[C]
package require Tk
package require snit
package require dgw::tvmixins
::dgv::tvband [ttk::treeview pathName ?options?] ?options?
::dgv::tvfilebrowser [ttk::treeview pathName ?options?] ?options?
::dgv::tvksearch [ttk::treeview pathName ?options?] ?options?
::dgv::tvsortable [ttk::treeview pathName ?options?] ?options?
::dgv::tvtooltip [ttk::treeview pathName ?options?] ?options?
::dgv::tvfilebrowser [dgw::tvband [dgw::tvsortable [dgw::tvsearch \[rs]
     [ttk::treeview pathName ?options?] ?options?] ?options?] ?options?]
\f[R]
.fi
.SS DESCRIPTION
.PP
The package \f[B]dgw::tvmixins\f[R] implements several
\f[I]snit::widgetadaptor\f[R]s which extend the standard
\f[I]ttk::treeview\f[R] widget with different functionalities.
Different adaptors can be chained together to add the required
functionalities.
.SS WIDGET COMMANDS
.PP
\f[B]dgw::tvband\f[R] \f[I][ttk::treeview pathName] ?\-option value
\&...?\f[R]
.PP
Creates and configures the \f[I]dgw::tvband\f[R] widget using the Tk
window id \f[I]pathName\f[R] and the given \f[I]options\f[R].
Please note that this adaptor might have performace issues and that the
\f[I]ttk::treeview\f[R] widget of Tk 8.7 probably will have a configure
option \f[I]\-striped\f[R] and \f[I]\-stripedbackgroundcolor\f[R] which
can replace this adaptor.
.PP
The following option is available:
.RS
.IP \[bu] 2
\f[I]\-bandcolors\f[R] \f[I]list\f[R] \- list of the two colors to be
displayed alternatively.
.RE
.PP
Example:
.RS
.IP
.nf
\f[C]
ttk::tvband [ttk::treeview .fb \-columns [list A B C] \-show heading
foreach col [list A B C] { .fb header $col \-text $col }
for {set i 0} {$i < 20} {incr i 1} {
\&.fb insert {} end \-values [list  [expr {int(rand()*100)}] \[rs]
[expr {int(rand()*1000)}] [expr {int(rand()*1000)}]]
}
pack .fb \-side top \-fill both \-expand yes
\f[R]
.fi
.RE
.PP
\f[B]dgw::tvfilebrowser\f[R] \f[I][ttk::treeview pathName] ?\-option
value \&...?\f[R]
.PP
Creates and configures the \f[I]dgw::tvfilebrowser\f[R] widget using the
Tk window id \f[I]pathName\f[R] and the given \f[I]options\f[R].
.PP
The following option is available:
.RS
.IP \[bu] 2
\f[I]\-directory dirName\f[R] \- starting directory for the filebrowser,
default current directory.
.IP \[bu] 2
\f[I]\-browsecmd cmdName\f[R] \- command to be executed if the users
double clicks on a row item or presses the Return key.
The widgets pathName and the acutal row index are appended to the
\f[I]cmdName\f[R] as arguments, default to empty string.
.IP \[bu] 2
\f[I]\-fileimage imgName\f[R] \- image to be displayed as filename image
left of the filename, default is standard file icon.
.RE
.PP
The following method(s) is(are) available:
.RS
.IP \[bu] 2
\f[I]browserDir dirName\f[R] \- the directory to be loaded into the
\f[I]dgw::tvfilebrowser\f[R] widget.
.RE
.PP
Example:
.RS
.IP
.nf
\f[C]
dgv::tvfilebrowser [dgw::tvsortable [dgw::tvsearch [dgw::tvband \[rs]
[ttk::treeview .fb]]] \[rs]
\-sorttypes [list Name directory Size real Modified dictionary]]
pack .fb \-side top \-fill both \-expand yes
\f[R]
.fi
.RE
.PP
\f[B]dgw::tvksearch\f[R] \f[I][ttk::treeview pathName] ?\-option value
\&...?\f[R]
.PP
Creates and configures the \f[I]dgw::tvksearch\f[R] widget using the Tk
window id \f[I]pathName\f[R] and the given \f[I]options\f[R].
With this widget you can use the Home and End keys for navigation and
further letter typing starts searching in the first column shifting
focus and display to the current matching entry.
.PP
There are currenlty no options or methods available for this widget.
.PP
Example:
.RS
.IP
.nf
\f[C]
dgv::tvfilebrowser [dgw::tvsearch [ttk::treeview .fb]] \[rs]
pack .fb \-side top \-fill both \-expand yes
\f[R]
.fi
.RE
.PP
\f[B]dgw::tvsortable\f[R] \f[I][ttk::treeview pathName] ?\-option value
\&...?\f[R]
.PP
Creates and configures the \f[I]dgw::tvsortable\f[R] widget using the Tk
window id \f[I]pathName\f[R] and the given \f[I]options\f[R].
.PP
The following option is available:
.RS
.IP \[bu] 2
\f[I]\-sorttypes\f[R] the options for the \f[I]lsort\f[R] command for
each of the columns, such as dictionary, ascii, real etc.
Default: real.
The values are given as a list of key\-value pairs where the key is the
column name.
In addition to teh standard \f[I]lsort\f[R] options as well the option
directory can be given if the widget contains results of a directory
listening with filenames and directory names.
In this case the directories are always above the filenames.
.RE
.PP
The widget further provides the following event:
.IP \[bu] 2
<<SortEnd>> \- with the following symbols %W (widget) and %d (row index)
.PP
Example:
.RS
.IP
.nf
\f[C]
dgw::tvsortable [ttk::tvband [ttk::treeview .fb \-columns [list A B C] \-show heading] \[rs]
\-sorttypes [list A real B real C integer]]
foreach col [list A B C] { .fb header $col \-text $col }
for {set i 0} {$i < 20} {incr i 1} {
\&.fb insert {} end \-values [list  [expr {int(rand()*100)}] \[rs]
[expr {int(rand()*1000)}] [expr {int(rand()*1000)}]]
}
pack .fb \-side top \-fill both \-expand yes
\f[R]
.fi
.RE
.PP
\f[B]dgw::tvtooltip\f[R] \f[I][ttk::treeview pathName] ?\-option value
\&...?\f[R]
.PP
Creates and configures the \f[I]dgw::tvtooltip\f[R] widget using the Tk
window id \f[I]pathName\f[R] and the given \f[I]options\f[R].
.PP
There are currently no options available.
.PP
The widget provides the following events:
.IP \[bu] 2
<<RowEnter>> with the following symbols: %d the row index, and the
standards %W (widget), %x (widgetX), %y (widgetY), %X (rootx), %Y
(rootY)
.IP \[bu] 2
<<RowLeave>> with the following symbols: %d the row index, and the
standards %W (widget), %x (widgetX), %y (widgetY), %X (rootx), %Y
(rootY)
.PP
Example:
.RS
.IP
.nf
\f[C]
set fb [dgw::tvtooltip [dgw::tvfilebrowser [ttk::treeview .fp2] \[rs]
\-directory . \-fileimage movie \-filepattern {\[rs].(3gp|mp4|avi|mkv|mp3|ogg)$}]
pack $fb \-side top \-fill both \-expand yes
pack [::ttk::label .msg \-font \[dq]Times 12 bold\[dq] \-textvariable ::msg \-width 20 \[rs]
\-background salmon \-borderwidth 2 \-relief ridge] \[rs]
\-side top \-fill x \-expand false \-ipadx 5 \-ipady 4
bind $fb <<RowEnter>> { set ::msg \[dq]  Entering row %d\[dq]}
bind $fb <<RowLeave>> { set ::msg \[dq]  Leaving row %d\[dq]}
\f[R]
.fi
.RE
.SS EXAMPLE
.PP
In the example below we create a filebrowser widget using all the widget
adaptors for demonstration purposes.
.IP
.nf
\f[C]
# wrapper function 
proc fbrowse {path args} {
     set fb [dgw::tvtooltip [dgw::tvksearch [dgw::tvfilebrowser [dgw::tvband \[rs]
        [ttk::treeview $path]] {*}$args]]]
     return $fb
}
set f [ttk::frame .f]
set fb [fbrowse $f.fb]
pack $fb \-side left \-fill both \-expand yes
pack [ttk::scrollbar $f.yscroll \-command [list $fb yview]] \[rs]
      \-side left \-fill y \-expand false
$fb configure \-yscrollcommand [list $f.yscroll set]
pack $f \-side top \-fill both \-expand true
# demo tvtooltip
pack [::ttk::label .msg \-font \[dq]Times 12 bold\[dq] \-textvariable ::msg \-width 20 \[rs]
     \-background salmon \-borderwidth 2 \-relief ridge] \[rs]
     \-side left \-fill x \-expand false \-ipadx 5 \-ipady 4
bind $fb <<RowEnter>> { set ::msg \[dq]  Entering row %d\[dq]}
bind $fb <<RowLeave>> { set ::msg \[dq]  Leaving row %d\[dq]}
\f[R]
.fi
.SS INSTALLATION
.PP
Installation is easy you can install and use the \f[B]dgw::tvmixins\f[R]
package if you have a working install of:
.IP \[bu] 2
the snit package which can be found in tcllib \-
https://core.tcl\-lang.org/tcllib (https://core.tcl-lang.org/tcllib)
.PP
For installation you copy the complete \f[I]dgw\f[R] folder into a path
of your \f[I]auto_path\f[R] list of Tcl or you append the
\f[I]auto_path\f[R] list with the parent dir of the \f[I]dgw\f[R]
directory.
Alternatively you can install the package as a Tcl module by creating a
file dgw/tvmixins\-0.2.tm in your Tcl module path.
.SS DEMO
.PP
Example code for this package can be executed by running this file using
the following command line:
.IP
.nf
\f[C]
$ wish tvmixins.tcl \-\-demo
\f[R]
.fi
.PP
The example code used for this demo can be seen in the terminal by using
the following command line:
.IP
.nf
\f[C]
$ tclsh tvmixins.tcl \-\-code
\f[R]
.fi
.SS DOCUMENTATION
.PP
The script contains embedded the documentation in Markdown format.
To extract the documentation you should use the following command line:
.IP
.nf
\f[C]
$ tclsh tvmixins.tcl \-\-markdown
\f[R]
.fi
.PP
This will extract the embedded manual pages in standard Markdown format.
You can as well use this markdown output directly to create html pages
for the documentation by using the \f[I]\[en]html\f[R] flag.
.IP
.nf
\f[C]
$ tclsh tvmixins.tcl \-\-html
\f[R]
.fi
.PP
If the tcllib Markdown package is installed, this will directly create a
HTML page \f[C]tvmixins.html\f[R] which contains the formatted
documentation.
.PP
Github\-Markdown can be extracted by using the \f[I]\[en]man\f[R]
switch:
.IP
.nf
\f[C]
$ tclsh tvmixins.tcl \-\-man
\f[R]
.fi
.PP
The output of this command can be used to feed a Markdown processor for
conversion into a html, docx or pdf document.
If you have pandoc installed for instance, you could execute the
following commands:
.IP
.nf
\f[C]
tclsh ../tvmixins.tcl \-\-man > tvmixins.md
pandoc \-i tvmixins.md \-s \-o tvmixins.html
pandoc \-i tvmixins.md \-s \-o tvmixins.tex
pdflatex tvmixins.tex
\f[R]
.fi
.SS SEE ALSO
.IP \[bu] 2
dgw package
homepage (https://chiselapp.com/user/dgroth/repository/tclcode/index) \-
various useful widgets
.IP \[bu] 2
ttk::treeview widget
manual (https://www.tcl.tk/man/tcl8.6/TkCmd/ttk_treeview.htm) standard
manual page for the ttk::treeview widget
.SS CHANGES
.IP \[bu] 2
2020\-04\-10 \- version 0.2 released with adaptors: \f[I]tvband\f[R],
\f[I]tvfilebrowser\f[R], \f[I]tvksearch\f[R], \f[I]tvsortable\f[R],
\f[I]tvtooltip\f[R]
.SS TODO
.IP \[bu] 2
tkbook with book open and close images
.IP \[bu] 2
tkoutline with more images
.IP \[bu] 2
tests
.IP \[bu] 2
github url
.SS AUTHORS
.PP
The \f[B]dgw::tvmixins\f[R] widget was written by Detlef Groth,
Schwielowsee, Germany.
.SS Copyright
.PP
Copyright (c) 2020 Dr.\ Detlef Groth, E\-mail: detlef(at)dgroth(dot)de
.SS LICENSE
.PP
dgw::tvmixins package, version 0.2.
.PP
Copyright (c) 2019\-2020 Dr.\ Detlef Groth, E\-mail:
detlef(at)dgroth(dot)de
.PP
This library is free software; you can use, modify, and redistribute it
for any purpose, provided that existing copyright notices are retained
in all copies and that this notice is included verbatim in any
distributions.
.PP
This software is distributed WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
.SH AUTHORS
Detlef Groth, Schwielowsee, Germany.
